Index: /trunk/AUTHORS
===================================================================
--- /trunk/AUTHORS	(revision 289)
+++ /trunk/AUTHORS	(revision 290)
@@ -1,15 +1,15 @@
 Author:
-	Bas van der Vlies <basv@sara.nl>
+    Bas van der Vlies <bas.vandervlies@surfsara.nl>
 
 Configure and Debian package support: 
-	Yaroslav Halchenko
+    Yaroslav Halchenko
 
 PBSQuery module:
-	Bas van der Vlies
+    Bas van der Vlies
 
 Contributors:
-	Walter de Jong
-	Ramon Bastiaans
-	Dennis Stam
-	Sil Westerveld
-	Roy Dragseth (PBSQuery)
+    Walter de Jong
+    Ramon Bastiaans
+    Dennis Stam
+    Sil Westerveld
+    Roy Dragseth (PBSQuery)
Index: /trunk/CHANGES
===================================================================
--- /trunk/CHANGES	(revision 289)
+++ /trunk/CHANGES	(revision 290)
@@ -1,3 +1,3 @@
-=========== 4.X.X
+=========== 4.3.5
  * PBSQuery bugfix, parsing of node status line with multiple EVENT: settings
    was wrong
Index: /trunk/README
===================================================================
--- /trunk/README	(revision 289)
+++ /trunk/README	(revision 290)
@@ -1,10 +1,10 @@
 the latest stable pbs_python interface is available from:
-    ftp://ftp.sara.nl/pub/outgoing/pbs_python.tar.gz
+    ftp://ftp.surfsara.nl/pub/outgoing/pbs_python.tar.gz
 
 Information, documentation and reporting bugs for the package:
-    https://subtrac.sara.nl/oss/pbs_python
+    https://oss.trac.surfsara.nl/oss/pbs_python
 
 bug resport:
-    pbs_python@sara.nl
+    pbs_python@surfsara.nl
 
 =============== Brief description =============================
@@ -69,5 +69,5 @@
 
 For more info about SARA see:
-    http://www.sara.nl/index_eng.html
+    http://www.surfsara.nl/index_eng.html
 
 --
Index: /trunk/debian/changelog
===================================================================
--- /trunk/debian/changelog	(revision 289)
+++ /trunk/debian/changelog	(revision 290)
@@ -1,2 +1,10 @@
+pbs-python (4.3.5-1) lenny; urgency=low
+
+  * sara is now surfsara.nl, changed all references
+  * added a new code example for EVENT node parsing
+  * See Changes
+
+ -- Bas van der Vlies <bas.vandervlies@surfsara.nl>  Mon, 29 Apr 2013 17:21:39 +0200
+
 pbs-python (4.3.4-2) lenny; urgency=low
 
Index: /trunk/pbs_python.spec
===================================================================
--- /trunk/pbs_python.spec	(revision 289)
+++ /trunk/pbs_python.spec	(revision 290)
@@ -4,10 +4,10 @@
 
 Name: pbs_python
-Version: 4.3.4
+Version: 4.3.5
 Release: 1%{?dist}
 License: See LICENSE
 Group: Development/Libraries
 Summary: This package contains the PBS python module.
-URL: https://subtrac.sara.nl/oss/pbs_python
+URL: https://oss.trac.surfsara.nl/pbs_python
 BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
 Source: ftp://ftp.sara.nl/pub/outgoing/pbs_python.tar.gz 
Index: /trunk/setup.py.in
===================================================================
--- /trunk/setup.py.in	(revision 289)
+++ /trunk/setup.py.in	(revision 290)
@@ -17,7 +17,7 @@
 
 if not PBS_LIB_DIR:
-	print 'Please specify where the PBS libraries are!!'
-	print 'edit setup.py and fill in the PBS_LIB_DIR variable'
-	sys.exit(1)
+    print 'Please specify where the PBS libraries are!!'
+    print 'edit setup.py and fill in the PBS_LIB_DIR variable'
+    sys.exit(1)
 
 LIBS = ['torque']
@@ -39,41 +39,41 @@
 #
 try:
-	os.unlink('pbs.py')
-	os.unlink('pbs_wrap.c')
+    os.unlink('pbs.py')
+    os.unlink('pbs_wrap.c')
 except OSError:
-	pass
+    pass
 
 if major_version  >= 2 and minor_version >= 4 and build_version >= 7:
-	os.symlink('pbs_wrap_2.4.c', 'pbs_wrap.c')
-	os.symlink('pbs_2.4.py', 'pbs.py')
-	TORQUE_VERSION='TORQUE_2_4'
+    os.symlink('pbs_wrap_2.4.c', 'pbs_wrap.c')
+    os.symlink('pbs_2.4.py', 'pbs.py')
+    TORQUE_VERSION='TORQUE_2_4'
 else:
-	os.symlink('pbs_wrap_2.1.c', 'pbs_wrap.c')
-	os.symlink('pbs_2.1.py', 'pbs.py')
-	TORQUE_VERSION='TORQUE_OLD'
+    os.symlink('pbs_wrap_2.1.c', 'pbs_wrap.c')
+    os.symlink('pbs_2.1.py', 'pbs.py')
+    TORQUE_VERSION='TORQUE_OLD'
 
 os.chdir('..')
 
 setup ( 
-	name = 'pbs_python',
-	version = '4.1.3',
-	description = 'openpbs/torque python interface',
-	license = 'LGPLV3',
-	author = 'Bas van der Vlies',
-	author_email = 'basv@sara.nl',
-	url = 'http://subtrac.sara.nl/oss/pbs_python',
+    name = 'pbs_python',
+    version = '4.3.5',
+    description = 'openpbs/torque python interface',
+    license = 'LGPLV3',
+    author = 'Bas van der Vlies',
+    author_email = 'bas.vandervlies@surfsara.nl',
+    url = 'http://oss.trac.surfsara.nl/pbs_python',
 
 
-	extra_path = 'pbs',
-		package_dir = { '' : 'src' }, 
-		py_modules = [ 'pbs', 'PBSQuery', 'PBSAdvancedParser' ], 
+    extra_path = 'pbs',
+        package_dir = { '' : 'src' }, 
+        py_modules = [ 'pbs', 'PBSQuery', 'PBSAdvancedParser' ], 
 
-	ext_modules = [ 
-		Extension( '_pbs', ['src/pbs_wrap.c'],
-		library_dirs = [ PBS_LIB_DIR ],
-		extra_link_args = [ PBS_LIB_COMPILE_LINE ],
-		define_macros =  [ (TORQUE_VERSION, None) ],
-		libraries = LIBS,
-		) 
-	]
+    ext_modules = [ 
+        Extension( '_pbs', ['src/pbs_wrap.c'],
+        library_dirs = [ PBS_LIB_DIR ],
+        extra_link_args = [ PBS_LIB_COMPILE_LINE ],
+        define_macros =  [ (TORQUE_VERSION, None) ],
+        libraries = LIBS,
+        ) 
+    ]
 )