Index: /trunk/CHANGES
===================================================================
--- /trunk/CHANGES	(revision 315)
+++ /trunk/CHANGES	(revision 316)
@@ -1,2 +1,10 @@
+=========== 4.4.1
+ * new_rack_pbsmon.py: Added option -p/--property to filter on torque node properties
+ Requested by: Willem Vermin and Wim Rijks
+ Author: Dennis Stam
+
+ * Fixed docdir bug in configure.in and Makefile.in, closes #39
+ Author: Dennis Stam
+
 =========== 4.4.0
  * Drop support for versions older then 2.4
Index: /trunk/Makefile.in
===================================================================
--- /trunk/Makefile.in	(revision 315)
+++ /trunk/Makefile.in	(revision 316)
@@ -1,4 +1,6 @@
 TAR=tar
 GZIP_ENV=--best
+
+PACKAGE_TARNAME=@PACKAGE_TARNAME@
 
 PREFIX=@prefix@
@@ -6,6 +8,6 @@
 BINDIR=$(PREFIX)/bin
 
-DOCDIR=@docdir@ 
-EXAMPLES=$(DOCDIR)/examples
+DOCDIR=@docdir@
+EXAMPLES=$(PREFIX)/$(DOCDIR)/examples
 
 .PHONY: install pythonlib
@@ -17,7 +19,7 @@
 install: pythonlib
 	python ./setup.py install --prefix $(DESTDIR)/$(exec_prefix) ;
-	install -D LICENSE.openpbs $(DESTDIR)/$(DOCDIR)/LICENSE.openpbs
-	install -D COPYING $(DESTDIR)/$(DOCDIR)/COPYING
-	install -D COPYING.LESSER $(DESTDIR)/$(DOCDIR)/COPYING.LESSER
+	install -D LICENSE.openpbs $(DESTDIR)/$(PREFIX)/$(DOCDIR)/LICENSE.openpbs
+	install -D COPYING $(DESTDIR)/$(PREFIX)/$(DOCDIR)/COPYING
+	install -D COPYING.LESSER $(DESTDIR)/$(PREFIX)/$(DOCDIR)/COPYING.LESSER
 	(cd examples; for i in *py; do install -D $$i  $(DESTDIR)/$(EXAMPLES)/$${i}; done)
 
Index: /trunk/configure
===================================================================
--- /trunk/configure	(revision 315)
+++ /trunk/configure	(revision 316)
@@ -1,5 +1,5 @@
 #! /bin/sh
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.69.
+# Generated by GNU Autoconf 2.69 for pbs-python 4.4.1.
 #
 #
@@ -575,12 +575,12 @@
 
 # Identity of this package.
-PACKAGE_NAME=
-PACKAGE_TARNAME=
-PACKAGE_VERSION=
-PACKAGE_STRING=
-PACKAGE_BUGREPORT=
-PACKAGE_URL=
-
-ac_unique_file="src/PBSQuery.py"
+PACKAGE_NAME='pbs-python'
+PACKAGE_TARNAME='pbs-python'
+PACKAGE_VERSION='4.4.1'
+PACKAGE_STRING='pbs-python 4.4.1'
+PACKAGE_BUGREPORT=''
+PACKAGE_URL=''
+
+ac_unique_file="src/C++/pbs_wrap.cxx"
 ac_subst_vars='LTLIBOBJS
 LIBOBJS
@@ -685,5 +685,5 @@
 includedir='${prefix}/include'
 oldincludedir='/usr/include'
-docdir='${datarootdir}/doc/${PACKAGE}'
+docdir='${datarootdir}/doc/${PACKAGE_TARNAME}'
 infodir='${datarootdir}/info'
 htmldir='${docdir}'
@@ -1185,5 +1185,5 @@
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures this package to adapt to many kinds of systems.
+\`configure' configures pbs-python 4.4.1 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
@@ -1233,5 +1233,5 @@
   --localedir=DIR         locale-dependent data [DATAROOTDIR/locale]
   --mandir=DIR            man documentation [DATAROOTDIR/man]
-  --docdir=DIR            documentation root [DATAROOTDIR/doc/PACKAGE]
+  --docdir=DIR            documentation root [DATAROOTDIR/doc/pbs-python]
   --htmldir=DIR           html documentation [DOCDIR]
   --dvidir=DIR            dvi documentation [DOCDIR]
@@ -1245,5 +1245,7 @@
 
 if test -n "$ac_init_help"; then
-
+  case $ac_init_help in
+     short | recursive ) echo "Configuration of pbs-python 4.4.1:";;
+   esac
   cat <<\_ACEOF
 
@@ -1316,5 +1318,5 @@
 if $ac_init_version; then
   cat <<\_ACEOF
-configure
+pbs-python configure 4.4.1
 generated by GNU Autoconf 2.69
 
@@ -1333,5 +1335,5 @@
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by $as_me, which was
+It was created by pbs-python $as_me 4.4.1, which was
 generated by GNU Autoconf 2.69.  Invocation command line was
 
@@ -1686,4 +1688,6 @@
 
 
+
+
 pbsdir_default=''
 
@@ -2423,5 +2427,5 @@
 # values after options handling.
 ac_log="
-This file was extended by $as_me, which was
+This file was extended by pbs-python $as_me 4.4.1, which was
 generated by GNU Autoconf 2.69.  Invocation command line was
 
@@ -2476,5 +2480,5 @@
 ac_cs_config="`$as_echo "$ac_configure_args" | sed 's/^ //; s/[\\""\`\$]/\\\\&/g'`"
 ac_cs_version="\\
-config.status
+pbs-python config.status 4.4.1
 configured by $0, generated by GNU Autoconf 2.69,
   with options \\"\$ac_cs_config\\"
Index: /trunk/configure.in
===================================================================
--- /trunk/configure.in	(revision 315)
+++ /trunk/configure.in	(revision 316)
@@ -1,3 +1,8 @@
-AC_INIT(src/PBSQuery.py)
+#AC_INIT(src/PBSQuery.py)
+
+AC_PREREQ([2.69])
+AC_INIT([pbs-python], [4.4.1])
+AC_CONFIG_SRCDIR([src/C++/pbs_wrap.cxx])
+
 AC_SUBST(prefix)
 AC_SUBST(exec_prefix)
Index: /trunk/debian/changelog
===================================================================
--- /trunk/debian/changelog	(revision 315)
+++ /trunk/debian/changelog	(revision 316)
@@ -1,3 +1,9 @@
-pbs-python (4.4.0-1) UNRELEASED; urgency=low
+pbs-python (4.4.1-1) unstable; urgency=low
+
+  * See CHANGES
+
+ -- Dennis Stam <dennis.stam@surfsara.nl>  Wed, 04 Jun 2014 14:37:45 +0200
+
+pbs-python (4.4.0-1) unstable; urgency=low
 
   * See CHANGES
Index: /trunk/examples/new_rack_pbsmon.py
===================================================================
--- /trunk/examples/new_rack_pbsmon.py	(revision 315)
+++ /trunk/examples/new_rack_pbsmon.py	(revision 316)
@@ -104,5 +104,5 @@
 import curses
 curses.setupterm()
-if curses.tigetnum("colors") > 8:
+if curses.tigetnum("colors") > 2:
     TERMINAL_COLOR=True
 else:
Index: /trunk/pbs_python.spec
===================================================================
--- /trunk/pbs_python.spec	(revision 315)
+++ /trunk/pbs_python.spec	(revision 316)
@@ -4,5 +4,5 @@
 
 Name: pbs_python
-Version: 4.4.0
+Version: 4.4.1
 Release: 1%{?dist}
 License: See LICENSE
Index: /trunk/setup.py.in
===================================================================
--- /trunk/setup.py.in	(revision 315)
+++ /trunk/setup.py.in	(revision 316)
@@ -70,5 +70,5 @@
 setup ( 
     name = 'pbs_python',
-    version = '4.4.0',
+    version = '4.4.1',
     description = 'openpbs/torque python interface',
     license = 'LGPLV3',
Index: /trunk/src/C++/pbs.py
===================================================================
--- /trunk/src/C++/pbs.py	(revision 315)
+++ /trunk/src/C++/pbs.py	(revision 316)
@@ -952,6 +952,6 @@
   return d
 
-version_info = ( 4, 4, 0 )
-version = 'SARA pbs_python version 4.4.0'
+version_info = ( 4, 4, 1 )
+version = 'SARA pbs_python version 4.4.1'
 
 # A useful dict with error codes to text
Index: /trunk/src/C/pbs.py
===================================================================
--- /trunk/src/C/pbs.py	(revision 315)
+++ /trunk/src/C/pbs.py	(revision 316)
@@ -835,6 +835,6 @@
   return d
 
-version_info = ( 4, 4, 0 )
-version = 'SARA pbs_python version 4.4.0'
+version_info = ( 4, 4, 1 )
+version = 'SARA pbs_python version 4.4.1'
 
 # A useful dict with error codes to text