Index: devel/C/pbs.i
===================================================================
--- devel/C/pbs.i	(revision 318)
+++ devel/C/pbs.i	(revision 320)
@@ -272,4 +272,5 @@
     ptr = ptr->next;
   }
+  free(ptr);
 
   if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -300,4 +301,6 @@
     ptr = ptr->next;
   }
+
+  free(ptr);
   if (SARA_DEBUG) printf("\t</Contents>\n");
 } // end typemap struct attrl *
@@ -325,4 +328,6 @@
     ptr = ptr->next;
   }
+
+  free(ptr);
   if (SARA_DEBUG) printf("\t</Contents>\n");
 } // end typemap struct attropl *
Index: devel/C/pbs_wrap_2.1.c
===================================================================
--- devel/C/pbs_wrap_2.1.c	(revision 318)
+++ devel/C/pbs_wrap_2.1.c	(revision 320)
@@ -3526,4 +3526,6 @@
       ptr = ptr->next;
     }
+    
+    free(ptr);
     if (SARA_DEBUG) printf("\t</Contents>\n");
   }
@@ -3571,4 +3573,6 @@
       ptr = ptr->next;
     }
+    
+    free(ptr);
     if (SARA_DEBUG) printf("\t</Contents>\n");
   }
@@ -3616,4 +3620,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -3707,4 +3712,6 @@
       ptr = ptr->next;
     }
+    
+    free(ptr);
     if (SARA_DEBUG) printf("\t</Contents>\n");
   }
@@ -4067,4 +4074,6 @@
       ptr = ptr->next;
     }
+    
+    free(ptr);
     if (SARA_DEBUG) printf("\t</Contents>\n");
   }
@@ -4436,4 +4445,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -4575,4 +4585,6 @@
       ptr = ptr->next;
     }
+    
+    free(ptr);
     if (SARA_DEBUG) printf("\t</Contents>\n");
   }
@@ -6175,4 +6187,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -6296,4 +6309,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -6425,4 +6439,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -6546,4 +6561,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -6675,4 +6691,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
Index: devel/C/pbs_wrap_2.4.c
===================================================================
--- devel/C/pbs_wrap_2.4.c	(revision 318)
+++ devel/C/pbs_wrap_2.4.c	(revision 320)
@@ -3526,4 +3526,6 @@
       ptr = ptr->next;
     }
+    
+    free(ptr);
     if (SARA_DEBUG) printf("\t</Contents>\n");
   }
@@ -3571,4 +3573,6 @@
       ptr = ptr->next;
     }
+    
+    free(ptr);
     if (SARA_DEBUG) printf("\t</Contents>\n");
   }
@@ -3616,4 +3620,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -3707,4 +3712,6 @@
       ptr = ptr->next;
     }
+    
+    free(ptr);
     if (SARA_DEBUG) printf("\t</Contents>\n");
   }
@@ -4067,4 +4074,6 @@
       ptr = ptr->next;
     }
+    
+    free(ptr);
     if (SARA_DEBUG) printf("\t</Contents>\n");
   }
@@ -4436,4 +4445,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -4575,4 +4585,6 @@
       ptr = ptr->next;
     }
+    
+    free(ptr);
     if (SARA_DEBUG) printf("\t</Contents>\n");
   }
@@ -6175,4 +6187,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -6296,4 +6309,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -6425,4 +6439,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -6546,4 +6561,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");
@@ -6675,4 +6691,5 @@
       ptr = ptr->next;
     }
+    free(ptr);
     
     if (SARA_DEBUG) printf("\t</Contents>\n");